package
{
	import caurina.transitions.Tweener;
	
	import fl.controls.Button;
	
	import flash.display.Sprite;
	import flash.display.StageScaleMode;
	import flash.events.MouseEvent;
	import flash.filters.BlurFilter;
	import flash.filters.GlowFilter;

	[SWF(width="600", height="400", frameRate="30", backgroundColor="#000000")]
	public class DrawLineTest extends Sprite
	{	
		private var button:Button;
		private var isPlay:Boolean;
		private var shapeDatas:Array;
		
		public function DrawLineTest()
		{
			stage.scaleMode = StageScaleMode.NO_SCALE;
			super();
            isPlay = false;
            initButton();
            
            shapeDatas = new Array(4);
            var data:XML;
            var shapeDataSet:ShapeDataSet;
            var gf:GlowFilter = new GlowFilter(0x85FFA2, 1, 32, 32, 2, 2);
            var bf:BlurFilter = new BlurFilter(4,4,2);
            for(var i:uint = 0; i < 4; i++)
            {
            	data = DataPoolXML["data" + (i + 1)];
            	shapeDataSet = new ShapeDataSet(data);
            	shapeDataSet.filters = [bf,gf];
            	addChild(shapeDataSet);
            	shapeDatas[i] = shapeDataSet;
            }
		}
		
		private function initButton():void
		{
			button = new Button();
			addChild(button);
			button.label = "スタート";
			button.addEventListener(MouseEvent.CLICK, playStop); 
			button.move(stage.stageWidth - button.width -10, stage.stageHeight -button.height -10);
		}
		
		private function playStop(e:MouseEvent):void
		{
			if(isPlay)
			{
				Tweener.removeAllTweens();
				isPlay = false;
				button.label = "スタート";
			}
			else
			{
				isPlay = true;
				button.label = "ストップ";
				
				
				for(var i:uint = 0; i < shapeDatas.length; i++)
				{
					shapeDatas[i].drawAnime();
				}
			}
		}		
	}
}

import flash.display.Shape;
import flash.display.Sprite;
import caurina.transitions.Tweener;

class ShapeDataSet extends Sprite
{
    public var total:uint;
    public var cnt:uint;
    public var shape_data:ShapeData;
    public var thickness:Number;
    public var baseThickness:Number = 8;
    public var isIn:Boolean;
    public var lines:Array;
        
	public function ShapeDataSet(dat:XML):void
	{
        shape_data = new ShapeData(dat);
        cnt = 0;
        isIn = true;
        total = shape_data.edges.length;
        thickness = baseThickness;
        lines = new Array(total);
        var shape:Shape;
        for(var i:uint = 0; i < total; i++)
        {
            shape = new Shape();
            addChild(shape);
            lines[i] = shape;
        }
	}
	 
    public function drawAnime():void
    {
        var edge:Object;
        if(cnt < total)
        {
            edge = shape_data.edges[cnt];
            edge.setThickness(thickness, thickness - baseThickness / total);
            thickness -= baseThickness / total;
            if(isIn)
            {
                edge.start_t = 0;
                edge.end_t = 0;
                edge.beginFill(0xffffff, 1);
                Tweener.addTween(edge, {
                    end_t:1, 
                    time:0.1, 
                    transition:"linear", 
                    onUpdate:edge.draw, 
                    onUpdateParams:[lines[cnt].graphics], 
                    onComplete:drawAnime
                });
            }
            else
            {
                edge.start_t = 0;
                edge.end_t = 1;
                edge.beginFill(0xffffff, 1);
                Tweener.addTween(edge, {
                    start_t:1, 
                    time:0.1, 
                    transition:"linear", 
                    onUpdate:edge.draw, 
                    onUpdateParams:[lines[cnt].graphics], 
                    onComplete:drawAnime
                });
            }
            cnt++;
        }
        else
        {
            thickness = baseThickness;
            cnt = 0;
            isIn = !isIn;
            drawAnime();
        }
    }
}

