package
{
	import flash.display.Graphics;
	import flash.geom.Point;
	
	public class EdgeLineEx
	{
		private var baseLine:EdgeLine;
		private var segment:uint = 300; //分割数
        private var poses1:Array; //tに対応した位置
        private var poses2:Array;
        private var thicknesses:Object;
        private var color:uint = 0;
        private var alpha:Number = 1;
        public var start_t:Number;
        public var end_t:Number;
        
		public function EdgeLineEx(_p0:Point , _p1:Point , _p2:Point)
		{
			baseLine = new EdgeLine(_p0 , _p1 , _p2);
			start_t = 0;
			end_t = 1;
		}
		
        private function getTangentPoint(isIn:Boolean, distance:Number, t:Number):Point
        {
            var pt:Point = new Point();
            var angle:Number = Math.atan2(baseLine.dx, -baseLine.dy);
            var disX:Number = Math.cos(angle) * distance;
            var disY:Number = Math.sin(angle) * distance;
            var basePt:Point = baseLine.getPosAt(t);
            if(isIn)
            {
                pt.x = basePt.x + disX;
                pt.y = basePt.y + disY;
            }
            else
            {
                pt.x = basePt.x - disX;
                pt.y = basePt.y - disY;
            }
            return pt;
        }
        
        private function setPoses():void
        {
            poses1 = new Array(segment);
            poses2 = new Array(segment);
            var startPt1:Point = getTangentPoint(true, thicknesses.start / 2, 0);
            var endPt1:Point = getTangentPoint(true, thicknesses.end / 2, 1);
            var startPt2:Point = getTangentPoint(false, thicknesses.start / 2, 0);
            var endPt2:Point = getTangentPoint(false, thicknesses.end / 2, 1);
            var line1:EdgeLine = new EdgeLine(startPt1, new Point(0,0), endPt1);
            var line2:EdgeLine = new EdgeLine(startPt2, new Point(0,0), endPt2);
            var i:uint;
            var t:Number = 0;
            var dt:Number = 1 / segment;

            for(i = 0; i < segment; i++)
            {
               poses1[i] = line1.getPosAt(t);
               poses2[i] = line2.getPosAt(t);
               t += dt;
            }
        }
        
        public function setThickness(start:Number, end:Number):void
        {
            if(isNaN(end)){end = start}
            thicknesses = 
            {
                start:start, end:end
            }
            setPoses();
        }
        
        private function calcToSegment(target_t:Number):uint
        {
        	var seg:uint = segment * target_t;
            return (seg >= segment) ? segment - 1 : seg;
        }
        
        public function draw(g:Graphics):void
        {
            var startSeg:uint = calcToSegment(start_t);
            var endSeg:uint = calcToSegment(end_t);
            g.clear();
            g.beginFill(color, alpha);
            g.moveTo(poses1[startSeg].x, poses1[startSeg].y);
            g.lineTo(poses1[endSeg].x, poses1[endSeg].y);
            g.lineTo(poses2[endSeg].x, poses2[endSeg].y);
            g.lineTo(poses2[startSeg].x, poses2[startSeg].y);
            g.lineTo(poses1[startSeg].x, poses1[startSeg].y);
            g.endFill();
        }
        
        public function beginFill(color:uint = 0, alpha:Number = 1):void
        {
        	this.color = color;
        	this.alpha = alpha;
        }
	}
}