﻿
/**
 *	Shapeのデータ
 */

/**

XML
<shape>
<edge x0="" y0="" x1="" y1="" x2="" y2="" line="0|1" />
</shape>


*/
package {
	
	import flash.display.Graphics;
	import flash.geom.Point;
	
	public class ShapeData extends Object{
		
		
		public var edges:Array;
		
		public var rates:Array;
		
		private var length_:Number = Number.NaN;
		
		
		/**
		 *	コンストラクタ
		 */
		public function ShapeData( dat:XML ){
			makeData( dat );
			//length_ = getLength();
		}
		
		
		/**
		 *	XMLからデータ初期化
		 */
		private function makeData( dat:XML ):void{
			//
			edges = new Array();
			
			var tmp:Array = new Array();
			var p0:Point;
			var p1:Point;
			var p2:Point;
			for each (var edge:XML in dat.edge ){
				
				p0 = new Point( Number(edge.@x0) , Number(edge.@y0) );
				p1 = new Point( Number(edge.@x1) , Number(edge.@y1) );
				p2 = new Point( Number(edge.@x2) , Number(edge.@y2) );
				
				if( edge.@line=="0" ){
					tmp.push( new EdgeBezier( p0 , p1 , p2 ) );
					edges.push( new EdgeBezierEx(p0, p1, p2) );
				}else{
					tmp.push( new EdgeLine( p0 , p1 , p2 ) );
					edges.push( new EdgeLineEx(p0, p1, p2) );
				}
			}
			
			//edgeを順番に入れ替える
			/*
			edges.push( tmp[0] );
			var tx:Number = tmp[0].p2x;
			var ty:Number = tmp[0].p2y;
			
			tmp.shift();
			
			while( tmp.length>0 ){
				seekLoop : for( var i:uint=0;i<tmp.length;i++ ){
					if( tmp[i].p0x == tx && tmp[i].p0y == ty ){
						//
						edges.push( tmp[i] );
						//
						tx = tmp[i].p2x;
						ty = tmp[i].p2y;
						tmp.splice( i , 1 );
						break seekLoop;
					}
				}
			}
			*/
		}
		
		public function getEdgeAt( i:uint ):IEdge{
			return edges[i];
		}
		
		public function get length():uint{
			return edges.length;
		}
		
		
		/**
		 *	線の長さ
		 */
		public function get total_length():Number{
			return isNaN( length_ ) ? getLength() : length_;
		}
		
		private function getLength():Number{
			
			var i:int= 0;
			length_ = 0;
			for( i=0 ; i<edges.length ; i++ ){
				length_ += edges[i].length;
			}
			
			rates = new Array();
			for( i=0 ; i<edges.length ; i++ ){
				rates.push( edges[i].length/length_ );
			}
			
			return length_;
		}
		
		/**
		 *	線の描画
		 */
		public function draw( graphics:Graphics ):void{
			graphics.moveTo( edges[0].p0x , edges[0].p0y );
			for( var i:int=0;i<edges.length;i++ ){
				var ed:IEdge = edges[i];
				if( ed.isLine ){
					graphics.lineTo( ed.p2x , ed.p2y );
				}else{
					graphics.curveTo( ed.p1x , ed.p1y , ed.p2x , ed.p2y );
				}
			}
		}
		
	}
	
}